(* Generic Memoization Function *)

(* Version TP *)

let memo f =
  let tab = Hashtbl.create 101 in
  let rec aux x =
    try Hashtbl.find tab x with
      | Not_found ->
        Hashtbl.add tab x (f aux x);
        Hashtbl.find tab x
  in aux

let cont_fibo next = function
  | 0 | 1 as x -> x
  | x -> next (x-1) + next (x-2)

let fibo = memo cont_fibo

(* Version avec compte des appels *)

let memo f =
  let tab = Hashtbl.create 101 in
  let rec aux count x =
    try Hashtbl.find tab x with
      | Not_found ->
        incr count;
        Hashtbl.add tab x (f count aux x);
        Hashtbl.find tab x
  in aux

let cont_fibo count next = function
  | 0 | 1 as x -> x
  | x -> next count (x-1) + next count (x-2)

let fibo =
  let aux = memo cont_fibo in
  fun count value -> (count := 0; aux count value)

let main () =
  let count = ref 0 in
  begin
    for i=0 to 90 do
      Printf.printf "fibo count %d = %d (count = %d)\n"
        i (fibo count i) !count;
    done;
    exit 0;
  end
let _ = main ()

